<?php

/**
 * Functions which enhance the theme by hooking into WordPress
 *
 * @package constructio_engineer
 */


function construction_engineer_customize_css() {
    ?>
    <style type="text/css">
        :root {
            --primary-color: <?php echo esc_html( get_theme_mod( 'construction_engineer_primary_color', '#fab915' ) ); ?>;
        }
    </style>
    <?php
}
add_action( 'wp_head', 'construction_engineer_customize_css' );


function add_custom_script_in_footer() {
    if ( get_theme_mod( 'construction_engineer_enable_sticky_header', false ) ) {
        ?>
        <script>
            jQuery(document).ready(function($) {
                $(window).on('scroll', function() {
                    var scroll = $(window).scrollTop();
                    if (scroll > 0) {
                        $('.navigation-part.hello').addClass('is-sticky');
                    } else {
                        $('.navigation-part.hello').removeClass('is-sticky');
                    }
                });
            });
        </script>
        <?php
    }
}
add_action( 'wp_footer', 'add_custom_script_in_footer' );


function construction_engineer_enqueue_selected_fonts() {
    $construction_engineer_fonts_url = construction_engineer_get_fonts_url();
    if (!empty($construction_engineer_fonts_url)) {
        wp_enqueue_style('construction-engineer-google-fonts', $construction_engineer_fonts_url, array(), null);
    }
}
add_action('wp_enqueue_scripts', 'construction_engineer_enqueue_selected_fonts');

function construction_engineer_layout_customizer_css() {
    $construction_engineer_margin = get_theme_mod('construction_engineer_layout_width_margin', 50);
    ?>
    <style type="text/css">
        body.site-boxed--layout #page  {
            margin: 0 <?php echo esc_attr($construction_engineer_margin); ?>px;
        }
    </style>
    <?php
}
add_action('wp_head', 'construction_engineer_layout_customizer_css');

function construction_engineer_blog_layout_customizer_css() {
    // Retrieve the blog layout option
    $construction_engineer_blog_layout_option = get_theme_mod('construction_engineer_blog_layout_option_setting', 'Left');

    // Initialize custom CSS variable
    $construction_engineer_custom_css = '';

    // Generate custom CSS based on the layout option
    if ($construction_engineer_blog_layout_option === 'Default') {
        $construction_engineer_custom_css .= '.mag-post-detail { text-align: center; }';
    } elseif ($construction_engineer_blog_layout_option === 'Left') {
        $construction_engineer_custom_css .= '.mag-post-detail { text-align: left; }';
    } elseif ($construction_engineer_blog_layout_option === 'Right') {
        $construction_engineer_custom_css .= '.mag-post-detail { text-align: right; }';
    }

    // Output the combined CSS
    ?>
    <style type="text/css">
        <?php echo wp_kses($construction_engineer_custom_css, array( 'style' => array(), 'text-align' => array() )); ?>
    </style>
    <?php
}
add_action('wp_head', 'construction_engineer_blog_layout_customizer_css');

function construction_engineer_sidebar_width_customizer_css() {
    $construction_engineer_sidebar_width = get_theme_mod('construction_engineer_sidebar_width', '30');
    ?>
    <style type="text/css">
        .right-sidebar .asterthemes-wrapper .asterthemes-page {
            grid-template-columns: auto <?php echo esc_attr($construction_engineer_sidebar_width); ?>%;
        }
        .left-sidebar .asterthemes-wrapper .asterthemes-page {
            grid-template-columns: <?php echo esc_attr($construction_engineer_sidebar_width); ?>% auto;
        }
    </style>
    <?php
}
add_action('wp_head', 'construction_engineer_sidebar_width_customizer_css');

if ( ! function_exists( 'construction_engineer_get_page_title' ) ) {
    function construction_engineer_get_page_title() {
        $construction_engineer_title = '';

        if (is_404()) {
            $construction_engineer_title = esc_html__('Page Not Found', 'construction-engineer');
        } elseif (is_search()) {
            $construction_engineer_title = esc_html__('Search Results for: ', 'construction-engineer') . esc_html(get_search_query());
        } elseif (is_home() && !is_front_page()) {
            $construction_engineer_title = esc_html__('Blogs', 'construction-engineer');
        } elseif (function_exists('is_shop') && is_shop()) {
            $construction_engineer_title = esc_html__('Shop', 'construction-engineer');
        } elseif (is_page()) {
            $construction_engineer_title = get_the_title();
        } elseif (is_single()) {
            $construction_engineer_title = get_the_title();
        } elseif (is_archive()) {
            $construction_engineer_title = get_the_archive_title();
        } else {
            $construction_engineer_title = get_the_archive_title();
        }

        return apply_filters('construction_engineer_page_title', $construction_engineer_title);
    }
}

if ( ! function_exists( 'construction_engineer_has_page_header' ) ) {
    function construction_engineer_has_page_header() {
        // Default to true (display header)
        $construction_engineer_return = true;

        // Custom conditions for disabling the header
        if ('hide-all-devices' === get_theme_mod('construction_engineer_page_header_visibility', 'all-devices')) {
            $construction_engineer_return = false;
        }

        // Apply filters and return
        return apply_filters('construction_engineer_display_page_header', $construction_engineer_return);
    }
}

if ( ! function_exists( 'construction_engineer_page_header_style' ) ) {
    function construction_engineer_page_header_style() {
        $construction_engineer_style = get_theme_mod('construction_engineer_page_header_style', 'default');
        return apply_filters('construction_engineer_page_header_style', $construction_engineer_style);
    }
}

function construction_engineer_page_title_customizer_css() {
    $construction_engineer_layout_option = get_theme_mod('construction_engineer_page_header_layout', 'left');
    ?>
    <style type="text/css">
        .asterthemes-wrapper.page-header-inner {
            <?php if ($construction_engineer_layout_option === 'flex') : ?>
                display: flex;
                justify-content: space-between;
                align-items: center;
            <?php else : ?>
                text-align: <?php echo esc_attr($construction_engineer_layout_option); ?>;
            <?php endif; ?>
        }
    </style>
    <?php
}
add_action('wp_head', 'construction_engineer_page_title_customizer_css');

function construction_engineer_pagetitle_height_css() {
    $construction_engineer_height = get_theme_mod('construction_engineer_pagetitle_height', 50);
    ?>
    <style type="text/css">
        header.page-header {
            padding: <?php echo esc_attr($construction_engineer_height); ?>px 0;
        }
    </style>
    <?php
}
add_action('wp_head', 'construction_engineer_pagetitle_height_css');

function construction_engineer_site_logo_width() {
    $construction_engineer_site_logo_width = get_theme_mod('construction_engineer_site_logo_width', 200);
    ?>
    <style type="text/css">
        .site-logo img {
            max-width: <?php echo esc_attr($construction_engineer_site_logo_width); ?>px;
        }
    </style>
    <?php
}
add_action('wp_head', 'construction_engineer_site_logo_width');

function construction_engineer_menu_font_size_css() {
    $construction_engineer_menu_font_size = get_theme_mod('construction_engineer_menu_font_size', 16);
    ?>
    <style type="text/css">
        .main-navigation a {
            font-size: <?php echo esc_attr($construction_engineer_menu_font_size); ?>px;
        }
    </style>
    <?php
}
add_action('wp_head', 'construction_engineer_menu_font_size_css');

//Menu Font Weight
function construction_engineer_menu_font_weight_css() {
	$construction_engineer_font_weight = get_theme_mod( 'construction_engineer_menu_font_weight', 500);

	$construction_engineer_custom_css = "
		.main-navigation a {
		    font-weight: {$construction_engineer_font_weight};
		}
	";

	wp_add_inline_style( 'construction-engineer-style', $construction_engineer_custom_css );
}
add_action( 'wp_enqueue_scripts', 'construction_engineer_menu_font_weight_css' );

// Featured Image Dimension
function construction_engineer_custom_featured_image_css() {
    $construction_engineer_dimension = get_theme_mod('construction_engineer_blog_post_featured_image_dimension', 'default');
    $construction_engineer_width = get_theme_mod('construction_engineer_blog_post_featured_image_custom_width', '');
    $construction_engineer_height = get_theme_mod('construction_engineer_blog_post_featured_image_custom_height', '');
    
    if ($construction_engineer_dimension === 'custom' && $construction_engineer_width && $construction_engineer_height) {
        $construction_engineer_custom_css = "body:not(.single-post) .mag-post-single .mag-post-img img { width: {$construction_engineer_width}px !important; height: {$construction_engineer_height}px !important; }";
        wp_add_inline_style('construction-engineer-style', $construction_engineer_custom_css);
    }
}
add_action('wp_enqueue_scripts', 'construction_engineer_custom_featured_image_css');

// Featured Image Border Radius
function construction_engineer_featured_image_border_radius_css() {
    $construction_engineer_featured_image_border_radius = get_theme_mod('construction_engineer_featured_image_border_radius', 10);
    ?>
    <style type="text/css">  
        .mag-post-single img {
            border-radius: <?php echo esc_attr($construction_engineer_featured_image_border_radius); ?>px;
        }
    </style>
    <?php
}
add_action('wp_head', 'construction_engineer_featured_image_border_radius_css');

function construction_engineer_sidebar_widget_font_size_css() {
    $construction_engineer_sidebar_widget_font_size = get_theme_mod('construction_engineer_sidebar_widget_font_size', 24);
    ?>
    <style type="text/css">
        h2.wp-block-heading,aside#secondary .widgettitle,aside#secondary .widget-title {
            font-size: <?php echo esc_attr($construction_engineer_sidebar_widget_font_size); ?>px;
        }
    </style>
    <?php
}
add_action('wp_head', 'construction_engineer_sidebar_widget_font_size_css');

// Woocommerce Related Products Settings
function construction_engineer_related_product_css() {
    $construction_engineer_related_product_show_hide = get_theme_mod('construction_engineer_related_product_show_hide', true);

    if ( $construction_engineer_related_product_show_hide != true) {
        ?>
        <style type="text/css">
            .related.products {
                display: none;
            }
        </style>
        <?php
    }
}
add_action('wp_head', 'construction_engineer_related_product_css');

// Woocommerce Product Sale Position 
function construction_engineer_product_sale_position_customizer_css() {
    $construction_engineer_layout_option = get_theme_mod('construction_engineer_product_sale_position', 'left');
    ?>
    <style type="text/css">
        .woocommerce ul.products li.product .onsale {
            <?php if ($construction_engineer_layout_option === 'left') : ?>
                right: auto;
                left: 0px;
            <?php else : ?>
                left: auto;
                right: 0px;
            <?php endif; ?>
        }
    </style>
    <?php
}
add_action('wp_head', 'construction_engineer_product_sale_position_customizer_css'); 

//Footer Social Icon Alignment
function construction_engineer_footer_icons_alignment_css() {
    $construction_engineer_footer_social_align = get_theme_mod( 'construction_engineer_footer_social_align', 'center' );   
    ?>
    <style type="text/css">
        .socialicons {
            text-align: <?php echo esc_attr( $construction_engineer_footer_social_align ); ?> 
        }

        /* Mobile Specific */
        @media screen and (max-width: 575px) {
            .socialicons {
                text-align: center;
            }
        }
    </style>
    <?php
}
add_action( 'wp_head', 'construction_engineer_footer_icons_alignment_css' );

//Copyright Alignment
function construction_engineer_footer_copyright_alignment_css() {
    $construction_engineer_footer_bottom_align = get_theme_mod( 'construction_engineer_footer_bottom_align', 'center' );   
    ?>
    <style type="text/css">
        .site-footer .site-footer-bottom .site-footer-bottom-wrapper {
            justify-content: <?php echo esc_attr( $construction_engineer_footer_bottom_align ); ?> 
        }

        /* Mobile Specific */
        @media screen and (max-width: 575px) {
            .site-footer .site-footer-bottom .site-footer-bottom-wrapper {
                justify-content: center;
                text-align:center;
            }
        }
    </style>
    <?php
}
add_action( 'wp_head', 'construction_engineer_footer_copyright_alignment_css' );

//Copyright Font Size
function construction_engineer_copyright_font_size_css() {
    $construction_engineer_copyright_font_size = get_theme_mod('construction_engineer_copyright_font_size', 16);
    ?>
    <style type="text/css">
        .site-footer-bottom .site-info span {
            font-size: <?php echo esc_attr($construction_engineer_copyright_font_size); ?>px;
        }
    </style>
    <?php
}
add_action('wp_head', 'construction_engineer_copyright_font_size_css');

// Preloader Background Color Setting
function construction_engineer_preloader_background_colors_css() {
    $construction_engineer_preloader_background_color_setting = get_theme_mod('construction_engineer_preloader_background_color_setting', '');
        // Only output CSS if a color is set
        if (empty($construction_engineer_preloader_background_color_setting)) {
            return;
        }
    ?>
    <style type="text/css">
        #loader {
            background-color: <?php echo esc_attr($construction_engineer_preloader_background_color_setting); ?>;
        }
    </style>
    <?php
}
add_action('wp_head', 'construction_engineer_preloader_background_colors_css');

// Preloader Background Image Setting
function construction_engineer_preloader_background_image_css() {
    $construction_engineer_preloader_background_image_setting = get_theme_mod('construction_engineer_preloader_background_image_setting', '');
        // Only output CSS if the background image is set
        if (empty($construction_engineer_preloader_background_image_setting)) {
            return;
        }
    ?>
    <style type="text/css">
        #loader {
            background-image: url('<?php echo esc_url($construction_engineer_preloader_background_image_setting); ?>');
            background-size: cover;
            background-repeat: no-repeat;
            background-position: center;
        }
    </style>
    <?php
}
add_action('wp_head', 'construction_engineer_preloader_background_image_css');

//Footer Heading Alignment
function construction_engineer_footer_heading_alignment_css() {
    $construction_engineer_footer_header_align = get_theme_mod( 'construction_engineer_footer_header_align', 'left' );   
    ?>
    <style type="text/css">
        .site-footer h4, footer#colophon h2.wp-block-heading, footer#colophon .widgettitle, footer#colophon .widget-title {
            text-align: <?php echo esc_attr( $construction_engineer_footer_header_align ); ?> 
        }
    </style>
    <?php
}
add_action( 'wp_head', 'construction_engineer_footer_heading_alignment_css' );

//First Capital Letter
function construction_engineer_show_first_caps() {
	$construction_engineer_first_caps = get_theme_mod('construction_engineer_show_first_caps', false);
	$construction_engineer_css = '';
	if ( $construction_engineer_first_caps ) {
	$construction_engineer_css .= '
		.mag-post-single .mag-post-detail .mag-post-excerpt p:first-of-type::first-letter {
		    font-size: 55px;
			font-weight: 600;
			margin-right: 6px;
			line-height: 1;
			display: inline-block;
			vertical-align: baseline;
		}';
	} else {
		$construction_engineer_css .= '
		.mag-post-single .mag-post-detail .mag-post-excerpt p:first-of-type::first-letter {
			display: none;
		}';
	}
	wp_add_inline_style( 'construction-engineer-style', $construction_engineer_css );
}
add_action( 'wp_enqueue_scripts', 'construction_engineer_show_first_caps' );

// Banner Button Color
function construction_engineer_banner_button_color_css() {
    $btn_color = get_theme_mod('construction_engineer_banner_btn_color');
    $btn_bg_color = get_theme_mod('construction_engineer_banner_btn_bg_color');
    $btn_border_color = get_theme_mod('construction_engineer_banner_btn_border_color');

    $custom_css = '';

    if ( !empty($btn_color) ) {
        $custom_css .= "
        .banner-slider-btn a.asterthemes-button,
        .banner-slider-btn2 a.asterthemes-button {
            color: {$btn_color};
        }";
    }

    if ( !empty($btn_bg_color) ) {
        $custom_css .= "
        .banner-slider-btn a.asterthemes-button,
        .banner-slider-btn2 a.asterthemes-button {
            background-color: {$btn_bg_color};
        }";
    }

    if ( !empty($btn_border_color) ) {
        $custom_css .= "
        .banner-slider-btn2 a.asterthemes-button {
            border: 2px solid {$btn_border_color};
        }";
    }

    wp_add_inline_style('construction-engineer-style', $custom_css);
}
add_action('wp_enqueue_scripts','construction_engineer_banner_button_color_css');